      Program bsbpkd
c     Programma dimostrativo della subroutine bsbpk
      
      external bsbpk
      
      integer dim
      parameter (dim=10)
      
      real u(dim*(dim+1)/2),b(dim)             
      integer n,ifail,log
      character*12 fin,fout
                         
      log=13
      
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE BSBPK ***'
      print*
      write(*,10)'Ordine del sistema (max ',dim,') = '
      read(*,*)n      

c     apro un file di log
      open(log,FILE='bsb.log')
      

      print*,'Nome del file di input = '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n*(n+1)/2
         read(11,*)u(i)
    1 continue
      read(11,*)
      do 2 i=1,n
         read(11,*)b(i)
    2 continue
      close(11)
      print*
      
      call bsbpk(u,b,n,ifail,log)
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
       
      print*,'Nome del file di output = '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)(b(i),i=1,n)
      close(12)                    
      
      print*,'Soluzione del sistema = '
      write(*,20)(b(i),i=1,n)
        
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
      
      End
      stop     