      integer function btrev(z,k)
c  
c  SCOPO: operazione di bit-reversal degli ultimi k bit della 
c         rappresentazione binaria di un intero
c
c  PARAMETRI DI INPUT:
c
c  -     z,  intero,  operando
c  -     k,  intero,  numero di bit da invertire
c
c  PARAMETRI DI OUTPUT:
c
c  - z,  intero,  risultato
c                       
c  ROUTINES RICHIAMATE:
c
c  - nessuna
c
       integer z,k
       integer z1
       
       z1=z

       do i=1,k/2
          if (btest(z1,i-1) .and. (.not. btest(z1,k-i))) then
             z1=ibclr(z1,i-1)
             z1=ibset(z1,k-i)
          elseif ((.not. btest(z1,i-1)) .and. btest(z1,k-i)) then
             z1=ibset(z1,i-1)
             z1=ibclr(z1,k-i)
          endif
       end do
   
       btrev=z1
       
      End
      stop