      Program chold
c     Programma dimostrativo della subroutine chol

      external chol
      
      integer dim
      parameter (dim=100)
       
      real a(dim*(dim+1)/2),l(dim*(dim+1)/2)                    
      integer n,ifail
      character*12 fin,fout
       
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE CHOL ***'
      print*
      write(*,10)'Ordine della matrice (max ',dim,') = '
      read(*,*)n       
            
      print*,'Nome del file di input = '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n*(n+1)/2
         read(11,*)a(i)   
    1 continue
      close(11)
            
      call chol(a,l,n,ifail)
       
      if (ifail .eq. 3) stop 'Errore! dimensioni non valide'
      if (ifail .eq. 5) stop 'Errore! matrice non definita positiva'
       
      print*,'Nome del file di output = '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)(l(i),i=1,n*(n+1)/2)
      close(12) 
            
      print*,'Matrice fattorizzata = '
      write(*,20)(l(i),i=1,n*(n+1)/2)
        
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
   
      end
      stop                                     