      Program fsbpkd
c     Programma dimostrativo della subroutine fsbpk
      
      external fsbpk
      
      integer dim
      parameter (dim=100)
      
      real l(dim*(dim+1)/2),b(dim)             
      integer n,ifail
      character*12 fin,fout
            
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE FSBPK ***'
      print*
      write(*,10)'Ordine del sistema (max ',dim,') ='
      read(*,*)n      
      print*      
      print*,'Nome del file di input ='
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 1 i=1,n*(n+1)/2
         read(11,*)l(i)
    1 continue
      read(11,*)
      do 2 i=1,n
         read(11,*)b(i)
    2 continue
      close(11)                                 
      print*
      
      call fsbpk(l,b,n,ifail)
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
       
      print*,'Nome del file di output ='
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)(b(i),i=1,n)
      close(12)                    
      
      print*,'Soluzione del sistema ='
      write(*,20)(b(i),i=1,n)
        
   10 format (1X,A,I3,A)
   20 format (1X,E14.7)  
      
      End
      stop     