      Program lupsd
c     Programma dimostrativo della subroutine lups

      external lups
      
      integer dim
      parameter (dim=6)
       
      real a(dim,dim),s(dim)
      integer ipiv(dim),n,ifail
      character*12 fin,fout
       
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE LUPS ***'
      print*
      write(*,10)'Ordine della matrice (max ',dim,')= '
      read(*,*)n       
      
      print*,'Nome del file di input= '
      read(*,'(A)')fin
      open(11,FILE=fin,STATUS='OLD')
      do 2 i=1,n
         do 1 j=1,n
            read(11,*)a(i,j)
    1    continue
    2 continue  
      close(11)
      
      call lups(a,dim,n,ipiv,s,ifail)
       
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
       
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
      write(12,20)((a(i,j),j=1,n),i=1,n)
      write(12,*)
      write(12,30)(ipiv(i),i=1,n)
      close(12) 
      
      print*,'Matrice fattorizzata= '
      write(*,20)((a(ipiv(i),j),j=1,n),i=1,n)
        
   10 format (1X,A,I2,A)
   20 format (1X,E14.7)  
   30 format (1X,I3)
   
      End
      stop                                     