      real function minr()
c
c  SCOPO: calcolo del minimo numero positivo di un sistema 
c         floating-point.
c        
c  PARAMETRI DI INPUT:  
c 
c  - nessuno
c
c  PARAMETRI DI OUTPUT:
c
c  - minr,  reale,  minimo numero positivo rappresentabile
c   
c  ROUTINES RICHIAMATE:
c
c  - eps,  funzione reale,  epsilon macchina 
c            
       real eps
       external eps
       
       real xold,xnew
 
       xnew=1.0
   10  if (xnew.eq.0) goto 20
          xold=xnew
          xnew=xold/2
       goto 10
   20  continue
       
c     Operazione di shift left della mantissa al fine di
c     ottenere il minimo rappresentabile del sistema
c     floating-point normalizzato
       minr=xold/(2*eps())

      End
	stop