      Program ode45d
c     Programma dimostrativo della subroutine ode 45

      external ode45
      
      real f6
      external f6
      
      integer dim
      parameter (dim=100)
      
      real a,b,y0,tol,x(dim),y(dim)
      integer m,n,ifail
      character*12 fout
      
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE ODE45 ***'
      print*
      print*,'Risoluzione dell''equazione y''=-30*y'
      print*
      print*,'Estremi dell''intervallo= '
      read(*,*)a,b
      print*,'Valore iniziale= '
      read(*,*)y0
      print*,'Numero iniziale di intervalli= '
      read(*,*)m
      print*,'Tolleranza richiesta= '
      read(*,*)tol
      write(*,10)'Numero massimo di valori da calcolare max(',dim,')= '
      read(*,*)n
      
      call ode45(f6,a,b,y0,m,tol,n,x,y,ifail)
            
      if (ifail .eq. 2) stop 'Errore! tolleranza assoluta non valida'
      if (ifail .eq. 11) stop 'Errore! numero di punti non valido'
      if (ifail .eq. 23) stop 'Errore! estremi non ordinati'
      if (ifail .eq. 24) 
     %    stop 'Errore! numero iniziale di intervalli non valido'
      if (ifail .eq. 25) 
     %    print*,'Attenzione! estremo destro non raggiunto'
      if (ifail .eq. 26)
     %    print*,'Attenzione! superamento del passo minimo'
      
      print*
      print*,'Nome del file di output= '
      read(*,'(A)')fout
      open(12,FILE=fout)
c      write(12,*)'Soluzione tabellata su',n,' punti'
      write(12,20)(x(i),i=1,n)
      write(12,*)
      write(12,20)(y(i),i=1,n)
      close(12)                    
      
      write(*,10)'Soluzione tabellata su ',n,' punti:'
      write(*,30)'x=','y='
      write(*,40)(x(i),y(i),i=1,n)
            
   10 format(1X,A,I3,A)
   20 format(2X,E15.7)
   30 format(1X,A2,14X,A2)
   40 format(1X,E15.7,1X,E15.7)
      
      End
      stop