      Program slupd02
c     Programma dimostrativo della subroutine slup  

      external lup
      external slup
      
      integer dim
      parameter (dim=6)
       
      real lu(dim,dim),b(dim)   
      real*4 temp 
      integer p(dim),n,ifail
c      character*12 fout
c     
c     lu matrice LU fattorizzata da lup
c     p vettore delle permutazioni
c     n ordine del sistema 
c     b vettore dei termini noti in input, vettore soluzione in output      
      print*
      print*,'*** PROGRAMMA DIMOSTRATIVO DELLA SUBROUTINE SLUP02b01 ***'
      print*
      write(*,10)'Ordine del sistema (max ',dim,') ='
      read(*,*)n    
      
c     genero una matrice di numeri casuali n*n
      call seed(RND$TIMESEED)
      call random(temp)
      
      do 2 i=1,n
         do 1 j=1,n 
            call random(temp)  
            lu(i,j) = temp
    1    continue
    2 continue               
      
      open(12,FILE='A')   
                                                         
      do 6 i=1,n
          do 5 j=1,n
              write(12,20)lu(i,j)
    5     continue
    6 continue
      close(12) 

c     genero un vettore di termini noti 
      open(12,FILE='b')
      do 4 i=1,n
          call random(temp)
          b(i) = temp
    4 continue   

c     salvo il vettore dei termini noti
      write(12,20)(b(i),i=1,n)
      close(12)
      print*,'vettore termini noti'
      write(*,*)(b(i),i=1,n)   

c     eseguo la fattorizzazione lu della matrice
      
      call lup(lu,dim,n,p,ifail)

c     calcolo LUx=b
      call slup(lu,p,b,dim,n,ifail)   
      
c     il vettore b in uscita contiene la soluzione del sistema

c     salvo il vettore soluzione
      open(12,FILE='sol')
      write(12,20)(b(i),i=1,n)      
      close(12)
      
      print*,'vettore soluzione'
      write(*,*)(b(i),i=1,n)      
            
      if (ifail .eq. 3) stop 'Errore! dimensione non valida'
      if (ifail .eq. 4) stop 'Errore! matrice singolare'
       
      print*,'Soluzione del sistema='
      write(*,20)(b(i),i=1,n)
      
   10 format (1X,A,I3,A)  
   15 format (1X,I1)     
   20 format (1X,E14.7)  
   
      End                                     