      real function tolm(x)
c
c  SCOPO: calcolo della tolleranza minima relativa ad un numero x
c         di un sistema floating-point.
c        
c  PARAMETRI DI INPUT:  
c 
c  - x,  reale,  numero di cui calcolare la tolleranza relativa
c
c  PARAMETRI DI OUTPUT:
c
c  - tolm,  reale,  tolleranza minima reltiva ad x
c   
c  ROUTINES RICHIAMATE:
c
c  -  eps,  funzione reale,  epsilon macchina
c  - minr,  funzione reale,  minimo rappresentabile
c
       real eps,minr
       external eps,minr
       
       real e,m,x
           
       e=eps()
       m=minr()
       if (abs(x).gt.m/(2*e)) then
          tolm=abs(x)*2*e
       else 
          tolm=m
       endif

      End
	stop   